#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mount.h>
#include <dlfcn.h>
#include "inkview.h"
#include <time.h>
time_t rawtime;
struct tm * timeinfo;

char *about = "Clocky\n\nVersion 1.15\n\nhttp://tiny.cc/Clocky";
char *about_rus = "Clocky\n\nВерсия 1.15\n\nhttp://tiny.cc/Clocky";

int errmsg;
char *errmsgtxt = "Wrong date ! ! !";
int this_month = 2;
int this_year = 2012;

char *default_font = "LiberationSerif";
int myfontsize = 344;
int myfontsize2 = 55; 
char *mask = "%H %M";
char *mask2 = "%d / %u";

ifont *myfont;
ifont *myfont2;
int main_handler(int type, int par1, int par2);
char kbuffer[256];
char buffer [80];
char empty[256];
int cindex=1;
int activ=1;
int fullupdate = 1;
int fullupdate_minutes = 10;
int minutes = -1;
int i;
int e; // english language
iconfig *ini;
int is_long = 0;	// sign of long key press

imenu menu1[] = {
	{ ITEM_ACTIVE, 100, "Refresh", NULL },
	{ ITEM_ACTIVE, 133, "Config", NULL },
	{ ITEM_ACTIVE, 444, "Rotate", NULL },
	{ ITEM_ACTIVE, 110, "Font", NULL },
	{ ITEM_ACTIVE, 111, "Font 2", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 999, "About", NULL },
	{ ITEM_ACTIVE, 777, "Exit", NULL },
	{ 0, 0, NULL, NULL }
};
imenu menu1_rus[] = {
	{ ITEM_ACTIVE, 100, "Обновить", NULL },
	{ ITEM_ACTIVE, 133, "Настройки", NULL },
	{ ITEM_ACTIVE, 444, "Повернуть", NULL },
	{ ITEM_ACTIVE, 110, "Размер шрифта", NULL },
	{ ITEM_ACTIVE, 111, "Размер шрифта сверху", NULL },
	{ ITEM_SEPARATOR, 0, NULL, NULL },
	{ ITEM_ACTIVE, 999, "О программе", NULL },
	{ ITEM_ACTIVE, 777, "Выход", NULL },
	{ 0, 0, NULL, NULL }
};


static iconfigedit testce[] = {
	{ CFG_FONTFACE, NULL, "Font", NULL, "font", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Font size",  NULL, "fontsize", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Font size of top text",  NULL, "fontsize2", NULL, NULL, NULL },
	{ CFG_TEXT, NULL, "Text mask",  NULL, "mask", NULL, NULL, NULL },
	{ CFG_TEXT, NULL, "Top text mask",  NULL, "mask2", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Full screen update (minutes)",  NULL, "fullupdate", NULL, NULL, NULL },
	{ 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
};

static iconfigedit testce_rus[] = {
	{ CFG_FONTFACE, NULL, "Шрифт", NULL, "font", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Размер шрифта",  NULL, "fontsize", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Размер шрифта сверху",  NULL, "fontsize2", NULL, NULL, NULL },
	{ CFG_TEXT, NULL, "Текст",  NULL, "mask", NULL, NULL, NULL },
	{ CFG_TEXT, NULL, "Текст сверху",  NULL, "mask2", NULL, NULL, NULL },
	{ CFG_NUMBER, NULL, "Полное обновление экрана (минуты)",  NULL, "fullupdate", NULL, NULL, NULL },
	{ 0, NULL, NULL, NULL, NULL, NULL, NULL, NULL }
};



char *replace_str(char *str, char *orig, char *rep){
  static char buffer[4096];
  char *p;
  if(!(p = strstr(str, orig))) return str;
  strncpy(buffer, str, p-str);
  buffer[p-str] = '\0';
  sprintf(buffer+(p-str), "%s%s", rep, p+strlen(orig));
  return buffer;
}


void mainscreen_repaint() {
	ClearScreen();
	time(&rawtime);
	timeinfo = localtime(&rawtime);
	
	SetFont(myfont, BLACK);
	strftime(buffer, 80, mask, timeinfo);
	DrawString((ScreenWidth() - StringWidth(buffer)) / 2, -120, buffer);	// time

	SetFont(myfont2, BLACK);
	sprintf(kbuffer, "%i°", GetTemperature());
	DrawString(10, 10, kbuffer);		// temperature
	sprintf(kbuffer, "%i", GetBatteryPower());
	DrawString(ScreenWidth()-StringWidth(kbuffer)-10, 10, kbuffer);		// battery
	strftime(buffer, 80, mask2, timeinfo);
	DrawString((ScreenWidth() - StringWidth(buffer)) / 2, 10, buffer);		// date
	
	if (errmsg) DrawString((ScreenWidth() - StringWidth(errmsgtxt)) / 2, ScreenHeight() - 100, errmsgtxt);
	
	if (fullupdate_minutes != 0){
		strftime(buffer, 80, "%M", timeinfo);
		switch (fullupdate_minutes){
			case 5: if (buffer[1] == '0' || buffer[1] == '5') fullupdate = 1; break;
			case 10: if (buffer[1] == '0') fullupdate = 1; break;
			case 15: if ((strcmp(buffer, "00")==0) || (strcmp(buffer, "15")==0) || (strcmp(buffer, "30")==0) || (strcmp(buffer, "45")==0)) fullupdate = 1; break;
			case 20: if ((strcmp(buffer, "00")==0) || (strcmp(buffer, "20")==0) || (strcmp(buffer, "40")==0)) fullupdate = 1; break;
			case 30: if ((strcmp(buffer, "00")==0) || (strcmp(buffer, "30")==0)) fullupdate = 1; break;
			case 60: if (strcmp(buffer, "00")==0) fullupdate = 1; break;
			default: if (minutes == fullupdate_minutes){ fullupdate = 1; minutes = 0; }  break;
		}
	}
	
	if (fullupdate) FullUpdate(); else SoftUpdate();
	fullupdate = 0;
}

void TimerDo() {
	//if (!activ) return;
	minutes++;
	mainscreen_repaint();
	SetHardTimer("TimerDo", TimerDo, 60000);
}

void change_font(int fs) {
	if (fs){
		myfontsize = fs;
		myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
		WriteInt(ini, "fontsize", fs);
		mainscreen_repaint();
	}
}

void change_font2(int fs) {
	if (fs){
		myfontsize2 = fs;
		myfont2 = OpenFont(ReadString(ini, "font", default_font), myfontsize2, 0);
		WriteInt(ini, "fontsize2", fs);
		mainscreen_repaint();
	}
}

void rotate(){
	if (GetOrientation() != 1) i = 1; else i = 2;
	SetOrientation(i);
	WriteInt(ini, "orientation", i);
	fullupdate = 1;
	mainscreen_repaint();
}

void config_ok() {
	if (ReadInt(ini, "fontsize", 0)) myfontsize = ReadInt(ini, "fontsize", 0);
	myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
	if (ReadInt(ini, "fontsize2", 0)) myfontsize2 = ReadInt(ini, "fontsize2", 0);
	myfont2 = OpenFont(ReadString(ini, "font", default_font), myfontsize2, 0);
	mask = ReadString(ini, "mask", "");
	mask2 = ReadString(ini, "mask2", "");
	fullupdate_minutes = ReadInt(ini, "fullupdate", 0);
	minutes = 0;
	activ = 1;
	TimerDo();
}


void menu1_handler(int index) {
	cindex = index;
	switch (index) {
		case 100:
			fullupdate = 1; mainscreen_repaint();
			break;	
			
		case 133:
			ClearTimer(TimerDo);
			activ = 0;
			OpenConfigEditor(e?"Configuration":"Настройки", ini, e?testce:testce_rus, config_ok, NULL);
			break;
			
		case 444:
			rotate();
			break;
			
		case 110:
			OpenPageSelector(change_font);
			break;		
			
		case 111:
			OpenPageSelector(change_font2);
			break;

		case 777:
			CloseApp();
			break;
			
		case 999:
			Message(0, e?"About":"О программе", e?about:about_rus, 99999);
			break;
	}
}

int main_handler(int type, int par1, int par2) {
 
	if (type == EVT_INIT) {	// occurs once at startup, only in main handler
		ini = OpenConfig(CONFIGPATH "/Clocky.ini", NULL);
		SetOrientation(ReadInt(ini, "orientation", 1));			//if (GetOrientation() != 1 && GetOrientation() != 4) SetOrientation(1);
		if (strcmp(ReadString(ini, "font", ""), "") == 0) WriteString(ini, "font", default_font);
		if (strcmp(ReadString(ini, "mask", ""), "") == 0) WriteString(ini, "mask", mask); else mask = ReadString(ini, "mask", "");
		if (strcmp(ReadString(ini, "mask2", ""), "") == 0) WriteString(ini, "mask2", mask2); else mask2 = ReadString(ini, "mask2", "");
		if (ReadInt(ini, "fullupdate", 0)) fullupdate_minutes = ReadInt(ini, "fullupdate", 0); else WriteInt(ini, "fullupdate", fullupdate_minutes);
		if (ReadInt(ini, "fontsize", 0)) myfontsize = ReadInt(ini, "fontsize", 0); else WriteInt(ini, "fontsize", myfontsize);
		if (ReadInt(ini, "fontsize2", 0)) myfontsize2 = ReadInt(ini, "fontsize2", 0); else WriteInt(ini, "fontsize2", myfontsize2);
		myfont = OpenFont(ReadString(ini, "font", default_font), myfontsize, 0);
		myfont2 = OpenFont(ReadString(ini, "font", default_font), myfontsize2, 0);
		
		iconfig *gc = GetGlobalConfig();
		if (strcmp(ReadString(gc, "language", "en") , "ru") == 0) e = 0; else e = 1; // language detect
		
		time(&rawtime);
		timeinfo = localtime(&rawtime);
		if (timeinfo->tm_year + 1900 < this_year || (timeinfo->tm_year + 1900 == this_year && timeinfo->tm_mon+1 < this_month)) errmsg = 1;
		
		SetAutoPowerOff(0);
		SetHardTimer("TimerDo", TimerDo, 500);
	}

	if (type == EVT_SHOW) {	// occurs when this event handler becomes active
		//mainscreen_repaint();
	}
	
	if (type == EVT_KEYPRESS && activ == 0) return 0;
	if ((type == EVT_POINTERDOWN || type == EVT_KEYUP) && activ == 0) { // keypress or touch - come out from sleep
		activ = 1;
		TimerDo(); 
		return 0;
	}

	
	if (type == EVT_POINTERDOWN) { 	//CalibrateTouchpanel();
		OpenMenu(e?menu1:menu1_rus, cindex, par1, par2, menu1_handler);
	}

	if (type == EVT_KEYREPEAT) { switch (par1) {
			case KEY_LEFT: CloseApp(); break;
			case KEY_RIGHT: OpenPageSelector(change_font); break;
			case KEY_UP: break;
			case KEY_DOWN:  break;
			case KEY_OK: 
				is_long = 1;
				break;
	} }

	if (type == EVT_KEYUP) { switch (par1) {
			case KEY_OK:
				if (is_long == 0) OpenMenu(e?menu1:menu1_rus, cindex, 100, 100, menu1_handler);
				is_long = 0;
				break;
				
			case KEY_DOWN:
				if (activ == 1){ // go to sleep mode
					ClearTimer(TimerDo);
					activ = 0;
					ClearScreen(); 
					DrawLine(300, ScreenHeight()/2, ScreenWidth()-300, ScreenHeight()/2, BLACK); 
					SoftUpdate(); 
				}
				break;
	} }
	
	if (type == EVT_KEYPRESS) {
		switch (par1) {

			case KEY_PLUS:
				break;

			case KEY_MINUS:
				break;

			case KEY_LEFT:
				CloseApp();
				break;

			case KEY_RIGHT:
				fullupdate = 1; 
				mainscreen_repaint();
				break;

			case KEY_UP:
				ClearTimer(TimerDo);
				activ = 0;
				OpenConfigEditor(e?"Configuration":"Настройки", ini, e?testce:testce_rus, config_ok, NULL);
				break;
				
			case KEY_DOWN:
				break;

			case KEY_MUSIC:
				rotate();
				break;

			case KEY_MENU:
				break;

			case KEY_BACK:
				CloseApp();
				break;

			case KEY_DELETE:	
				break;
		}
	}

	if (type == EVT_EXIT) {
		// occurs only in main handler when exiting or when SIGINT received - save configuration here, if needed
		SaveConfig(ini);
	}
	
	return 0;
}



int main(int argc, char **argv) {
	InkViewMain(main_handler);
	return 0;
}

